Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.Designer.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.Designer.cs	(revision 16240)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.Designer.cs	(revision 16240)
@@ -0,0 +1,197 @@
+﻿namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  partial class ProjectResourcesView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.inheritButton = new System.Windows.Forms.Button();
+      this.saveButton = new System.Windows.Forms.Button();
+      this.splitContainer = new System.Windows.Forms.SplitContainer();
+      this.resourcesGroupBox = new System.Windows.Forms.GroupBox();
+      this.treeView = new Hive.Views.TreeView.NoDoubleClickTreeView();
+      this.imageList = new System.Windows.Forms.ImageList(this.components);
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.detailsGroupBox = new System.Windows.Forms.GroupBox();
+      this.detailsViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.resourcesGroupBox.SuspendLayout();
+      this.detailsGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.refreshButton.Location = new System.Drawing.Point(3, 3);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 1;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh data");
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // inheritButton
+      // 
+      this.inheritButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.OrgChart;
+      this.inheritButton.Location = new System.Drawing.Point(33, 3);
+      this.inheritButton.Name = "inheritButton";
+      this.inheritButton.Size = new System.Drawing.Size(24, 24);
+      this.inheritButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.inheritButton, "Save and hand down resource assignments to all descendant projects");
+      this.inheritButton.UseVisualStyleBackColor = true;
+      this.inheritButton.Click += new System.EventHandler(this.inheritButton_Click);
+      // 
+      // saveButton
+      // 
+      this.saveButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
+      this.saveButton.Location = new System.Drawing.Point(63, 3);
+      this.saveButton.Name = "saveButton";
+      this.saveButton.Size = new System.Drawing.Size(24, 24);
+      this.saveButton.TabIndex = 3;
+      this.toolTip.SetToolTip(this.saveButton, "Save resource assignments");
+      this.saveButton.UseVisualStyleBackColor = true;
+      this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
+      // 
+      // splitContainer
+      // 
+      this.splitContainer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.splitContainer.Location = new System.Drawing.Point(3, 33);
+      this.splitContainer.Name = "splitContainer";
+      // 
+      // splitContainer.Panel1
+      // 
+      this.splitContainer.Panel1.Controls.Add(this.resourcesGroupBox);
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.detailsGroupBox);
+      this.splitContainer.Size = new System.Drawing.Size(824, 458);
+      this.splitContainer.SplitterDistance = 274;
+      this.splitContainer.TabIndex = 5;
+      // 
+      // resourcesGroupBox
+      // 
+      this.resourcesGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.resourcesGroupBox.Controls.Add(this.treeView);
+      this.resourcesGroupBox.Location = new System.Drawing.Point(3, 3);
+      this.resourcesGroupBox.Name = "resourcesGroupBox";
+      this.resourcesGroupBox.Size = new System.Drawing.Size(268, 452);
+      this.resourcesGroupBox.TabIndex = 0;
+      this.resourcesGroupBox.TabStop = false;
+      this.resourcesGroupBox.Text = "Resources (Assigned + Included)";
+      // 
+      // treeView
+      // 
+      this.treeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.treeView.CheckBoxes = true;
+      this.treeView.ImageIndex = 0;
+      this.treeView.ImageList = this.imageList;
+      this.treeView.Location = new System.Drawing.Point(6, 19);
+      this.treeView.Name = "treeView";
+      this.treeView.SelectedImageIndex = 0;
+      this.treeView.Size = new System.Drawing.Size(256, 427);
+      this.treeView.TabIndex = 0;
+      this.treeView.BeforeCheck += new System.Windows.Forms.TreeViewCancelEventHandler(this.treeView_BeforeCheck);
+      this.treeView.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.treeView_AfterCheck);
+      this.treeView.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.treeView_BeforeSelect);
+      this.treeView.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView_AfterSelect);
+      // 
+      // imageList
+      // 
+      this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.imageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.imageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // detailsGroupBox
+      // 
+      this.detailsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.detailsGroupBox.Controls.Add(this.detailsViewHost);
+      this.detailsGroupBox.Location = new System.Drawing.Point(3, 3);
+      this.detailsGroupBox.Name = "detailsGroupBox";
+      this.detailsGroupBox.Size = new System.Drawing.Size(540, 452);
+      this.detailsGroupBox.TabIndex = 0;
+      this.detailsGroupBox.TabStop = false;
+      this.detailsGroupBox.Text = "Details";
+      // 
+      // detailsViewHost
+      // 
+      this.detailsViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.detailsViewHost.Caption = "View";
+      this.detailsViewHost.Content = null;
+      this.detailsViewHost.Enabled = false;
+      this.detailsViewHost.Location = new System.Drawing.Point(6, 19);
+      this.detailsViewHost.Name = "detailsViewHost";
+      this.detailsViewHost.ReadOnly = true;
+      this.detailsViewHost.Size = new System.Drawing.Size(528, 427);
+      this.detailsViewHost.TabIndex = 0;
+      this.detailsViewHost.ViewsLabelVisible = true;
+      this.detailsViewHost.ViewType = null;
+      // 
+      // ProjectResourcesView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.splitContainer);
+      this.Controls.Add(this.saveButton);
+      this.Controls.Add(this.inheritButton);
+      this.Controls.Add(this.refreshButton);
+      this.Name = "ProjectResourcesView";
+      this.Size = new System.Drawing.Size(830, 494);
+      this.Load += new System.EventHandler(this.ProjectResourcesView_Load);
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+      this.splitContainer.ResumeLayout(false);
+      this.resourcesGroupBox.ResumeLayout(false);
+      this.detailsGroupBox.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button inheritButton;
+    private System.Windows.Forms.Button saveButton;
+    private System.Windows.Forms.SplitContainer splitContainer;
+    private System.Windows.Forms.GroupBox resourcesGroupBox;
+    private System.Windows.Forms.GroupBox detailsGroupBox;
+    private HeuristicLab.Clients.Hive.Views.TreeView.NoDoubleClickTreeView treeView;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.ImageList imageList;
+    private MainForm.WindowsForms.ViewHost detailsViewHost;
+  }
+}
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16240)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectResourcesView.cs	(revision 16240)
@@ -0,0 +1,522 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Clients.Access;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+using System.Collections;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  [View("ProjectView")]
+  [Content(typeof(Project), IsDefaultView = false)]
+  public partial class ProjectResourcesView : ItemView {
+    private const int slaveImageIndex = 0;
+    private const int slaveGroupImageIndex = 1;
+    public const string UNGROUPED_GROUP_NAME = "UNGROUPED";
+    public const string UNGROUPED_GROUP_DESCRIPTION = "Contains slaves that are not assigned to any group.";
+    public const string IMMUTABLE_TAG = " [assigned, immutable]";
+    public const string INCLUDED_TAG = " [included]";
+    public const string ADDED_ASSIGNMENT_TAG = " [added assignment]";
+    public const string REMOVED_ASSIGNMENT_TAG = " [removed assignment]";
+    public const string ADDED_INCLUDE_TAG = " [added include]";
+    public const string REMOVED_INCLUDE_TAG = " [removed include]";
+
+    private readonly HashSet<Resource> assignedResources = new HashSet<Resource>();
+    private readonly HashSet<Resource> newAssignedResources = new HashSet<Resource>();
+    private readonly HashSet<Resource> includedResources = new HashSet<Resource>();
+    private readonly HashSet<Resource> newIncludedResources = new HashSet<Resource>();
+
+    private readonly Color addedAssignmentColor = Color.FromArgb(255, 87, 191, 193); // #57bfc1
+    private readonly Color removedAssignmentColor = Color.FromArgb(255, 236, 159, 72); // #ec9f48
+    private readonly Color addedIncludeColor = Color.FromArgb(25, 169, 221, 221); // #a9dddd
+    private readonly Color removedIncludeColor = Color.FromArgb(25, 249, 210, 145); // #f9d291
+    private readonly Color selectedBackColor = Color.DodgerBlue;
+    private readonly Color selectedForeColor = Color.White;
+    private readonly Color grayTextColor = SystemColors.GrayText;
+
+    private HashSet<Resource> projectExclusiveResources = new HashSet<Resource>();
+    private TreeNode ungroupedGroupNode;
+
+    public new Project Content {
+      get { return (Project)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public ProjectResourcesView() {
+      InitializeComponent();
+
+      treeView.ImageList.Images.Add(VSImageLibrary.MonitorLarge);
+      treeView.ImageList.Images.Add(VSImageLibrary.NetworkCenterLarge);
+
+      HiveAdminClient.Instance.Refreshing += HiveAdminClient_Instance_Refreshing;
+      HiveAdminClient.Instance.Refreshed += HiveAdminClient_Instance_Refreshed;
+    }
+
+    #region Overrides
+    protected override void OnClosing(FormClosingEventArgs e) {
+      HiveAdminClient.Instance.Refreshed -= HiveAdminClient_Instance_Refreshed;
+      HiveAdminClient.Instance.Refreshing -= HiveAdminClient_Instance_Refreshing;
+      base.OnClosing(e);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        assignedResources.Clear();
+        newAssignedResources.Clear();
+        includedResources.Clear();
+        treeView.Nodes.Clear();
+        detailsViewHost.Content = null;
+      } else {
+        UpdateAssignedResources();
+        UpdateIncludedResources();
+        detailsViewHost.Content = BuildResourceTree();
+      }
+      SetEnabledStateOfControls();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      bool enabled = Content != null && !Locked && !ReadOnly;
+
+      inheritButton.Enabled = enabled;
+      saveButton.Enabled = enabled;
+      treeView.Enabled = enabled;
+
+      if (detailsViewHost != null) {
+        detailsViewHost.Locked = true;
+      }
+    }
+    #endregion
+
+    #region Event Handlers
+    private void HiveAdminClient_Instance_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshing, sender, e);
+      else {
+        SetEnabledStateOfControls();
+      }
+    }
+
+    private void HiveAdminClient_Instance_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveAdminClient_Instance_Refreshed, sender, e);
+      else {
+        OnContentChanged();
+      }
+    }
+
+    private void ProjectResourcesView_Load(object sender, EventArgs e) {
+
+    }
+
+    private void refreshButton_Click(object sender, EventArgs e) {
+      HiveAdminClient.Instance.Refresh();
+      UpdateAssignedResources();
+      UpdateIncludedResources();
+      var top = BuildResourceTree();
+      detailsViewHost.Content = top;
+    }
+
+    private async void inheritButton_Click(object sender, EventArgs e) {
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
+        action: () => {
+          SetAssignedProjectResources(Content.Id, newAssignedResources.Select(x => x.Id), false, true, false);
+        });
+      HiveAdminClient.Instance.Refresh();
+      UpdateResourceTree();
+    }
+
+    private async void saveButton_Click(object sender, EventArgs e) {
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
+        action: () => {
+          SetAssignedProjectResources(Content.Id, newAssignedResources.Select(x => x.Id), false, false, false);
+        });
+      HiveAdminClient.Instance.Refresh();
+      UpdateResourceTree();
+    }
+
+    private void treeView_BeforeSelect(object sender, TreeViewCancelEventArgs e) {
+      if (e.Node == null || e.Node == ungroupedGroupNode)
+        e.Cancel = true;
+
+      var selectedResource = (Resource)e.Node.Tag;
+      if(HiveAdminClient.Instance.DisabledParentResources.Contains(selectedResource))
+        e.Cancel = true;
+    }
+
+    private void treeView_AfterSelect(object sender, TreeViewEventArgs e) {
+      var selectedResource = (Resource)e.Node.Tag;
+      detailsViewHost.Content = selectedResource;
+    }
+
+    private void treeView_BeforeCheck(object sender, TreeViewCancelEventArgs e) {
+      if (e.Node == null || e.Node == ungroupedGroupNode) {
+        e.Cancel = true;
+        return;
+      }
+        
+      var checkedResource = (Resource)e.Node.Tag;
+      if (checkedResource == null
+        || checkedResource.Id == Guid.Empty
+        || HiveAdminClient.Instance.DisabledParentResources.Contains(checkedResource) 
+        || newIncludedResources.Contains(checkedResource)) {
+        e.Cancel = true;
+      } else if (!IsAdmin()) {
+          if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id) 
+            || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any() 
+            || projectExclusiveResources.Contains(checkedResource)) {
+            e.Cancel = true;
+          }
+      }
+    }
+
+    private void treeView_AfterCheck(object sender, TreeViewEventArgs e) {
+      var checkedResource = (Resource)e.Node.Tag;
+      if (e.Node.Checked) {
+        newAssignedResources.Add(checkedResource);
+      } else {
+        newAssignedResources.Remove(checkedResource);
+      }
+
+      UpdateNewResourceTree();
+    }
+    #endregion
+
+    #region Helpers
+
+    private void UpdateResourceTree() {
+      UpdateAssignedResources();
+      UpdateIncludedResources();
+
+      var top = BuildResourceTree();
+      detailsViewHost.Content = top;
+    }
+
+    private void UpdateNewResourceTree() {
+      UpdateNewAssignedResources();
+      UpdateNewIncludedResources();
+      var top = BuildResourceTree();
+      detailsViewHost.Content = top;
+    }
+
+    private IEnumerable<Resource> GetAvailableResourcesForProjectAdministration(Guid projectId) {
+      projectExclusiveResources.Clear();
+      if (projectId == Guid.Empty) return Enumerable.Empty<Resource>();
+      var resources = HiveAdminClient.Instance.Resources.Where(x => x.Id != Guid.Empty);
+      if (!resources.Any()) return resources;
+      if (IsAdmin()) return resources;
+
+      // get project specific assigned resources
+      var projectResources = resources.Where(x => 
+        HiveAdminClient.Instance.ProjectResourceAssignments
+          .Where(a => a.ProjectId == projectId)
+          .Select(a => a.ResourceId)
+        .Contains(x.Id));
+
+      // look up for assignments of ancestor projects
+      var projectIds = new HashSet<Guid>();
+      HiveAdminClient.Instance.GetAvailableProjectAncestors(projectId).ToList().ForEach(x => projectIds.Add(x.Id));
+
+      var ancestorProjectResources = resources.Where(x => 
+        HiveAdminClient.Instance.ProjectResourceAssignments
+          .Where(a => projectIds.Contains(a.ProjectId))
+          .Select(a => a.ResourceId)
+        .Contains(x.Id));
+
+      // look down for included resources of ancestor projects
+      HashSet<Resource> availableResources = new HashSet<Resource>(ancestorProjectResources);
+      foreach (var r in ancestorProjectResources) {
+        foreach(var d in HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id)) {
+          availableResources.Add(d);
+        }
+      }
+
+      // determine resources, which are exclusively assigned to the currently selected project
+      projectResources
+        .Except(availableResources)
+        .ToList()
+        .ForEach(x => projectExclusiveResources.Add(x));
+
+      // look down for included resources of currently selected project
+      if (projectExclusiveResources.Any()) {
+        foreach (var r in projectExclusiveResources.ToArray()) {
+          foreach (var d in HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id)) {
+            projectExclusiveResources.Add(d);
+          }  
+        }
+      }
+
+      return availableResources.Union(projectExclusiveResources);
+    }
+
+    private IEnumerable<Resource> GetAssignedResourcesForProject(Guid projectId) {
+      if (projectId == Guid.Empty) return Enumerable.Empty<Resource>();
+      return HiveAdminClient.Instance.Resources.Where(x =>
+        HiveAdminClient.Instance.ProjectResourceAssignments
+          .Where(a => a.ProjectId == projectId)
+          .Select(a => a.ResourceId)
+        .Contains(x.Id));
+    }
+
+    private void SetAssignedProjectResources(Guid projectId, IEnumerable<Guid> resourceIds, bool reassign, bool cascading, bool reassignCascading) {
+      if (projectId == null || resourceIds == null) return;
+      HiveServiceLocator.Instance.CallHiveService(s => {
+       s.SaveProjectResourceAssignments(projectId, resourceIds.ToList(), reassign, cascading, reassignCascading);
+      });
+    }
+
+    private void UpdateNewAssignedResources() {
+      for(int i = newAssignedResources.Count -1; i >= 0; i--) {
+        if(newAssignedResources.Intersect(HiveAdminClient.Instance.GetAvailableResourceAncestors(newAssignedResources.ElementAt(i).Id)).Any()) {
+          newAssignedResources.Remove(newAssignedResources.ElementAt(i));
+        }
+      }
+    }
+
+    private void UpdateAssignedResources() {
+      assignedResources.Clear();
+      newAssignedResources.Clear();
+      foreach (var r in GetAssignedResourcesForProject(Content.Id)) {
+        assignedResources.Add(r);
+        newAssignedResources.Add(r);
+      }
+    }
+
+    private void UpdateIncludedResources() {
+      includedResources.Clear();
+      newIncludedResources.Clear();
+      foreach (var a in assignedResources) {
+        foreach (var r in HiveAdminClient.Instance.GetAvailableResourceDescendants(a.Id)) {
+          includedResources.Add(r);
+          newIncludedResources.Add(r);
+        }
+      }
+    }
+
+    private void UpdateNewIncludedResources() {
+      newIncludedResources.Clear();
+      foreach (var a in newAssignedResources) {
+        foreach (var r in HiveAdminClient.Instance.GetAvailableResourceDescendants(a.Id)) {
+          newIncludedResources.Add(r);
+        }
+      }
+    }
+
+    private Resource BuildResourceTree() {
+      treeView.Nodes.Clear();
+
+      treeView.BeforeCheck -= treeView_BeforeCheck;
+      treeView.AfterCheck -= treeView_AfterCheck;
+
+      var resources = GetAvailableResourcesForProjectAdministration(Content.Id);
+
+      var disabledParentResources = HiveAdminClient.Instance.DisabledParentResources;
+      var mainResources = new HashSet<Resource>(resources.OfType<SlaveGroup>().Where(x => x.ParentResourceId == null));
+      //var parentedMainResources = new HashSet<Resource>(resources.OfType<SlaveGroup>()
+      //  .Where(x => x.ParentResourceId.HasValue && !resources.Select(y => y.Id).Contains(x.ParentResourceId.Value)));
+      //mainResources.UnionWith(parentedMainResources);
+      var mainDisabledParentResources = new HashSet<Resource>(disabledParentResources.Where(x => x.ParentResourceId == null || x.ParentResourceId == Guid.Empty));
+      mainResources.UnionWith(mainDisabledParentResources);
+      var subResources = new HashSet<Resource>(resources.Union(disabledParentResources).Except(mainResources).OrderByDescending(x => x.Name));
+
+      var stack = new Stack<Resource>(mainResources.OrderByDescending(x => x.Name));
+      
+      Resource top = null;
+      //bool nodeSelected = false;
+      if (detailsViewHost != null && detailsViewHost.Content != null && detailsViewHost.Content is Resource) {
+        var resourceId = ((Resource)detailsViewHost.Content).Id;
+        top = resources.Where(x => x.Id == resourceId).FirstOrDefault();
+      }
+      
+
+      TreeNode currentNode = null;
+      Resource currentResource = null;
+
+      var addedAssignments = newAssignedResources.Except(assignedResources);
+      var removedAssignments = assignedResources.Except(newAssignedResources);
+      var addedIncludes = newIncludedResources.Except(includedResources);
+      var removedIncludes = includedResources.Except(newIncludedResources);
+
+      while (stack.Any()) {
+        var newResource = stack.Pop();
+        var newNode = new TreeNode(newResource.Name) { Tag = newResource };
+
+        if(top == null && !disabledParentResources.Contains(newResource)) {
+          top = newResource;
+        }
+
+        //if(!nodeSelected && top != null && newResource.Id == top.Id) {
+        //  newNode.BackColor = selectedBackColor;
+        //  newNode.ForeColor = selectedForeColor;
+        //  nodeSelected = true;
+        //}
+
+        // search for parent node of newNode and save in currentNode
+        // necessary since newNodes (stack top items) might be siblings
+        // or grand..grandparents of previous node (currentNode)
+        while (currentNode != null && newResource.ParentResourceId != currentResource.Id) {
+          currentNode = currentNode.Parent;
+          currentResource = currentNode == null ? null : (Resource)currentNode.Tag;
+        }
+
+        if (currentNode == null) {
+          treeView.Nodes.Add(newNode);
+        } else {
+          currentNode.Nodes.Add(newNode);
+        }
+
+        if (disabledParentResources.Contains(newResource)) {
+          newNode.Checked = false;
+          newNode.ForeColor = grayTextColor;
+        } else if (newAssignedResources.Contains(newResource)) {
+          newNode.Checked = true;
+          if(!HiveRoles.CheckAdminUserPermissions()) {
+            if (!HiveAdminClient.Instance.CheckOwnershipOfParentProject(Content, UserInformation.Instance.User.Id) 
+              || !HiveAdminClient.Instance.GetAvailableProjectAncestors(Content.Id).Any() 
+              || projectExclusiveResources.Contains(newResource)) {
+              newNode.ForeColor = SystemColors.GrayText;
+              newNode.Text += IMMUTABLE_TAG;
+            }
+          }
+
+        } else if (newIncludedResources.Contains(newResource)) {
+          newNode.Checked = true;
+          newNode.ForeColor = SystemColors.GrayText;
+        }
+
+        if (includedResources.Contains(newResource) && newIncludedResources.Contains(newResource)) {
+          newNode.Text += INCLUDED_TAG;
+        } else if (addedIncludes.Contains(newResource)) {
+          newNode.BackColor = addedIncludeColor;
+          newNode.ForeColor = SystemColors.GrayText;
+          newNode.Text += ADDED_INCLUDE_TAG;
+        } else if (removedIncludes.Contains(newResource)) {
+          newNode.BackColor = removedIncludeColor;
+          newNode.Text += REMOVED_INCLUDE_TAG;
+        }
+
+        if (addedAssignments.Contains(newResource)) {
+          newNode.BackColor = addedAssignmentColor;
+          newNode.ForeColor = SystemColors.ControlText;
+          newNode.Text += ADDED_ASSIGNMENT_TAG;
+        } else if (removedAssignments.Contains(newResource)) {
+          newNode.BackColor = removedAssignmentColor;
+          newNode.ForeColor = SystemColors.ControlText;
+          newNode.Text += REMOVED_ASSIGNMENT_TAG;
+        }
+
+        if (newResource is Slave) {
+          newNode.ImageIndex = slaveImageIndex;
+        } else {
+          newNode.ImageIndex = slaveGroupImageIndex;
+
+          var childResources = subResources.Where(x => x.ParentResourceId == newResource.Id);
+          if (childResources.Any()) {
+            foreach (var resource in childResources.OrderByDescending(x => x.Name)) {
+              subResources.Remove(resource);
+              stack.Push(resource);
+            }
+            currentNode = newNode;
+            currentResource = newResource;
+          }
+        }
+        newNode.SelectedImageIndex = newNode.ImageIndex;
+      }
+
+      ExpandResourceNodesOfInterest(treeView.Nodes);
+
+      bool expandUngroupedGroupNode = false;
+      var ungroupedSlaves = subResources.OfType<Slave>().OrderBy(x => x.Name);
+      if(ungroupedSlaves.Any()) {
+        ungroupedGroupNode = new TreeNode(UNGROUPED_GROUP_NAME) {
+          ForeColor = SystemColors.GrayText,
+          Tag = new SlaveGroup() {
+            Name = UNGROUPED_GROUP_NAME,
+            Description = UNGROUPED_GROUP_DESCRIPTION
+          }
+        };
+
+        foreach (var slave in ungroupedSlaves) {
+          var slaveNode = new TreeNode(slave.Name) { Tag = slave };
+          if (newAssignedResources.Contains(slave)) {
+            slaveNode.Checked = true;
+            expandUngroupedGroupNode = true;
+          }
+
+          if (!HiveRoles.CheckAdminUserPermissions()) {
+            slaveNode.ForeColor = SystemColors.GrayText;
+            slaveNode.Text += IMMUTABLE_TAG;
+          } else {
+            if (addedAssignments.Contains(slave)) {
+              slaveNode.BackColor = addedAssignmentColor;
+              slaveNode.ForeColor = SystemColors.ControlText;
+              slaveNode.Text += ADDED_ASSIGNMENT_TAG;
+            } else if (removedAssignments.Contains(slave)) {
+              slaveNode.BackColor = removedAssignmentColor;
+              slaveNode.ForeColor = SystemColors.ControlText;
+              slaveNode.Text += REMOVED_ASSIGNMENT_TAG;
+              expandUngroupedGroupNode = true;
+            }
+          }
+          ungroupedGroupNode.Nodes.Add(slaveNode);
+        }
+
+        if(expandUngroupedGroupNode) ungroupedGroupNode.Expand();
+        treeView.Nodes.Add(ungroupedGroupNode);
+      } else if (ungroupedGroupNode != null) {
+        ungroupedGroupNode.Nodes.Clear();
+      }
+
+      treeView.BeforeCheck += treeView_BeforeCheck;
+      treeView.AfterCheck += treeView_AfterCheck;          
+
+      return top;
+    }
+
+    private void ExpandResourceNodesOfInterest(TreeNodeCollection nodes) {
+      foreach (TreeNode n in nodes) {
+        Resource r = (Resource)n.Tag;
+        if (n.Nodes.Count > 0) {
+          if (HiveAdminClient.Instance.GetAvailableResourceDescendants(r.Id).OfType<SlaveGroup>().Any()) {
+            n.Expand();
+            ExpandResourceNodesOfInterest(n.Nodes);
+          } else {
+            n.Collapse();
+          }
+        } else {
+          n.Collapse();
+        }
+      }
+    }
+
+    private bool IsAdmin() {
+      return HiveRoles.CheckAdminUserPermissions();
+    }
+
+    #endregion
+  }
+}
